package com.qmth.distributed.print.business.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.distributed.print.business.bean.params.TaskPrintParams;
import com.qmth.distributed.print.business.entity.ExamTaskPrint;
import com.qmth.distributed.print.business.mapper.ExamTaskPrintMapper;
import com.qmth.distributed.print.business.service.ExamTaskPrintService;
import com.qmth.teachcloud.common.entity.SysUser;
import com.qmth.teachcloud.common.util.ServletUtil;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @Date: 2021/8/2.
 */
@Service
public class ExamTaskPrintServiceImpl extends ServiceImpl<ExamTaskPrintMapper, ExamTaskPrint> implements ExamTaskPrintService {

    @Override
    public List<ExamTaskPrint> createTaskPrint(TaskPrintParams taskPrintParams) {
        Long schoolId = (Long) ServletUtil.getRequestHeaderSchoolId();
        SysUser sysUser = (SysUser) ServletUtil.getRequestUser();
        List<ExamTaskPrint> list = taskPrintParams.getList();
        list = list.stream().map(m -> {
            m.setPrintPlanId(taskPrintParams.getPrintPlanId());
            m.setCourseCode(taskPrintParams.getCourseCode());
            m.setCourseName(taskPrintParams.getCourseName());
            m.setPaperNumber(taskPrintParams.getPaperNumber());
            m.setExamStartTime(taskPrintParams.getExamStartTime());
            m.setExamEndTime(taskPrintParams.getExamEndTime());
            m.setSchoolId(schoolId);
            m.setOrgId(sysUser.getOrgId());
            m.setCreateId(sysUser.getId());
            return m;
        }).collect(Collectors.toList());

        this.saveBatch(list);
        return list;
    }
}
